#include "prefix.h"
#include "zero.h"

NTSTATUS KDevice::QueryInformation(PIRP Irp)
{
 PIO_STACK_LOCATION IrpSp;
 IrpSp=IoGetCurrentIrpStackLocation(Irp);
 FILE_INFORMATION_CLASS InfoClass=IrpSp->Parameters.QueryFile.FileInformationClass;
 printk("KDevice::QueryInformation(%ld, %lu)\n", InfoClass, IrpSp->Parameters.QueryFile.Length);
 NTSTATUS Status=STATUS_SUCCESS;
 switch(InfoClass)
 {
  case FileBasicInformation:
  {
   FILE_BASIC_INFORMATION BasicInfo;
   if(IrpSp->Parameters.QueryFile.Length<sizeof(BasicInfo))
   {
    Irp->IoStatus.Status = STATUS_BUFFER_TOO_SMALL;
    break;
   }
   LARGE_INTEGER Time;
   KeQuerySystemTime(&Time);
   BasicInfo.CreationTime=Time;
   BasicInfo.LastAccessTime=Time;
   BasicInfo.LastWriteTime=Time;
   BasicInfo.ChangeTime=Time;
   BasicInfo.FileAttributes=0;
   memcpy(Irp->AssociatedIrp.SystemBuffer, &BasicInfo, sizeof(BasicInfo));
   Irp->IoStatus.Information = sizeof(BasicInfo);
   break;
  }
 
  default:
   Irp->IoStatus.Information = 0;
   Status=STATUS_INVALID_DEVICE_REQUEST;
 }
 Irp->IoStatus.Status = Status;
 IoCompleteRequest(Irp, IO_NO_INCREMENT);
 return Status;
}
